## gnuplot 5.2.2+dfsg1

=== config/cygwin/Makefile ===
# Hey, Emacs, this is a -*- Makefile -*- #
# $Id: Makefile,v 1.11 2014/12/29 19:19:23 broeker Exp $
#
#
# GNUPLOT Makefile for Cygwin on WinNT and Win95/98/2000
#
# To compile gnuplot for WinXX:
#
# - check the beginning of this file settings you may want to change
#   You'll have to tell it where to find the Help Compiler, among other
#   things.
# - compile the package: go to directory 'gnuplot' and issue the commands
#	 make -C config/cygwin
#	 make install -C config/cygwin
# - resource compiler used is windres.exe in Cygwin
# - note pdf, png, and gif libraries if used have to be build for Cygwin
#   with former -mno-cygwin option
# - -static used for static linking to libz-w.a and libpng-w.a
#

#
# ************** Begin of Configuration section ************************
#

# Choose target to compile:
# 1. wgnuplot.exe: The usual Windows GUI for input commands.
# 2. wgnuplot_pipes.exe: The usual Windows GUI with support of pipes, so
#    that e.g.  plot '<awk -f preprocess.awk my.dat')  or  x=system('ls -1')
#    can work. Drawback: wgnuplot_pipes.exe keeps attached to a console (DOS)
#    window it was launched from, or it opens a new one.
# 3. gnuplot.exe: Console mode instead of GUI for the text input.
#
TARGET=wgnuplot.exe
#TARGET=wgnuplot_pipes.exe
#TARGET=gnuplot.exe

# Comment out the definition lines to disable the according features:

# GIF, PNG, JPEG device drivers
# Requires gd library. There are two possibilities how to configure these
# drivers for use in gnuplot, depending on the gd version. See README.1ST for
# more details. 
#
# You should compile gnuplot with GD library v2.0 or newer.
# This library writes PNG, GIF and JPEG images.
# If libgd has been compiled with TrueType font support, then you can use
# scaled TrueType fonts in png images. If not, then uncomment FREETYPE.
# Requires GD, PNG and Z libraries, optionally libfreetype.
#
#NEWGD=1
#JPEG=1
#FREETYPE=1

# PDF device driver
# requires PNG and Z libraries based on particular PDF library used
#PDF=1

# DEBUGging support
# creates binaries suitable for debugging. Some bugs may come and go
# as opposed to a production build since we lower the optimization level
#DEBUG=1

# MOUSE support for the windows terminal
MOUSE=1

# Below you can adapt paths according to your software setup:

# Where to place gnuplot.gih helpfile:
HELPFILE = wgnuplot.chm
BUILDHELPFILE = $(W)/$(HELPFILE)

# Where to install the PostScript prologue files, relatively to the executable
# wgnuplot.exe
GNUPLOT_PS_DIR = share/PostScript

# Similarly for javascript files for the canvas terminal:
GNUPLOT_JS_DIR = share/js

# Similarly for lua scripts used by the lua terminal
GNUPLOT_LUA_DIR = share/lua

# Destination directory, used in 'make install':
DESTDIR = /cygdrive/c/Apps/gnuplot

# give here the path to Gygwin GCC compiler unless it is already in PATH

#GCCPATH = /bin/
#GCCPATH =

# Do you want some special optimization?
CFLAGS =


# To compile the .chm file you need hcw either out of Microsoft SDK or MS HTML Help
# Workshop. The latter can be obtained at www.helpmaster.com/help/devaids.htm.
# Put the path to hcw here unless it is already in PATH:
HCWPATH = /cygdrive/c/Program\ Files/Help\ Workshop/
HCW = $(HCWPATH)hcw
# Switches are for HCW 4.03:
HCWFLAG =

# Choose which windres/rc do you want to use (GNU windres or MS RC):
GNU_RC = 1
ifndef GNU_RC
  # If uncommented GNU_RC above and rc.exe not in PATH, then set:
  MSSDK = c:/mssdk
endif

# GNU sort
#GNUSORT = gsort.exe
GNUSORT = /usr/bin/sort

#
# *************** End of Configuration section *************************


#
#         There shouldn't be anything to be changed below this line
# **********************************************************************
#

# PIPES: define if you would prefer support of pipes undef Windows (e.g.
# plot '<awk -f preprocess.awk my.dat'). Drawback: wgnuplot_pipes.exe keeps
# attached to a console=DOS window it was launched from, or it opens a new one.

# CONSOLE: define if you would prefer the console (non-GUI) version of the
# text command window.

# Set PIPES and CONSOLE according to the target
ifeq ($(TARGET),wgnuplot_pipes.exe)
	PIPES=1
endif
ifeq ($(TARGET),gnuplot.exe)
	PIPES=1
	CONSOLE=1
endif

CC = i686-pc-mingw32-gcc
LD = $(CC)

RM = rm -f
CP = cp -p

ifdef DEBUG
  CFLAGS += -g
  LDFLAGS += -g
else
  CFLAGS += -O2
  LDFLAGS += -s
endif

ifdef PIPES
  OPTS += -DPIPES
  LDFLAGS2 = -mconsole
endif

ifdef CONSOLE
  OPTS += -DWGP_CONSOLE
  LDFLAGS2 = -mconsole
endif

TOP = ../..

# macros for makefile.all
O=o
S=$(TOP)/src
W=$(S)/win
T=$(TOP)/term/
D=$(TOP)/docs/
L=docs/latex/
M=$(TOP)/demo/

VPATH = $(S)

TERMFLAGS = -DGNUPLOT_PS_DIR=\"$(GNUPLOT_PS_DIR)\" -DGNUPLOT_JS_DIR=\"$(GNUPLOT_JS_DIR)\" 
TERMFLAGS += -DGNUPLOT_LUA_DIR=\"$(GNUPLOT_LUA_DIR)\" -I$(TOP)/term
TERMLIBS =

CFLAGS += -I. -I$(S) -D_Windows -DCYGWIN -DHAVE_CONFIG_H\
	$(OPTS) $(EXTRA_CFLAGS)

# -I/usr/local/include

ifdef MOUSE
  CFLAGS += -DUSE_MOUSE=1 -DWIN_IPC
endif

ifdef NEWGD
  GD=1
  PNG=1
endif

ifdef GD
  CFLAGS += -DHAVE_LIBGD
  TERMLIBS += -lgd
endif

ifdef PNG
  CFLAGS += -DHAVE_LIBPNG
  TERMLIBS += -lpng -lz
endif

ifdef NEWGD
  CFLAGS += -DHAVE_GD_GIF -DGIF_ANIMATION -DHAVE_GD_PNG
ifdef JPEG
  CFLAGS += -DHAVE_GD_JPEG
  TERMLIBS += -ljpeg
endif
ifdef FREETYPE
  CFLAGS += -DHAVE_GD_TTF
  TERMLIBS += -lfreetype
endif
endif

ifdef PDF
  CFLAGS += -DHAVE_LIBPDF
  TERMLIBS += -lpdf-w -ltiff-w
ifndef PNG
  NEED_PNG_W = 1
else
ifndef NEWGD
  NEED_PNG_W = 1
endif
endif
ifdef NEED_PNG_W
  CFLAGS += -DHAVE_LIBPNG
  TERMLIBS += -lpng-w -lz-w
endif
endif

ifdef GNU_RC
  # RC = /bin/windres
  RC  = $(GCCPATH)windres
  RCFLAGS = --include-dir win \
	--define __WIN32__ --define __WIN95__ \
	--define __GNUWIN32__ --define WIN32
  RCOUT = wgplt_res.$(O)
  RES2COFF = echo wgplt_res.$(O)
else
  RC = $(MSSDK)/bin/rc
  RCFLAGS = -v -i$(MSSDK)/include -iwin \
	-dWIN32 -dMSRC
  RCOUT = -fowgnuplot.res
  RES2COFF = res2coff -i wgnuplot.res -o wgplt_res.$(O)
endif

default: $(TARGET) $(HELPFILE) wgnuplot.mnu $(M)bf_test.exe

all: default gnuplot.ps gnuplot.pdf


# include the 'core makefile template'
include $(S)/makefile.all

OBJS = $(COREOBJS) version.$(O) gpexecute.$(O)

WINOBJS = winmain.$(O) wgnuplib.$(O) wgraph.$(O) wprinter.$(O) wtext.$(O) \
	wpause.$(O) wmenu.$(O) screenbuf.$(O)

WINDOWS = makefile.win makefile.nt README.win $(W)/wcommon.h \
	$(W)/wgnuplib.c $(W)/wgnuplib.h $(W)/wgnuplib.rc \
	$(W)/wgnuplot.mnu $(W)/wgraph.c \
	$(W)/winmain.c $(W)/wmenu.c $(W)/wpause.c $(W)/wprinter.c \
	$(W)/wresourc.h $(W)/wtext.c $(W)/wtext.h \
	$(W)/screenbuf.c $(W)/screenbuf.h \
	$(T)win.trm $(W)/grpicon.ico $(W)/texticon.ico


# default rules
.SUFFIXES: .exe .o .c
.c.o:
	$(CC) -c $(CFLAGS) $<

LDLIBS = -L/usr/local/lib -lkernel32 -lgdi32 -lmsimg32 -lcomctl32

$(TARGET): $(OBJS) $(WINOBJS) wgplt_res.$(O)
	$(LD) $(LDFLAGS) $(LDFLAGS2) -mwindows -o $@ \
		$(OBJS) $(WINOBJS) wgplt_res.$(O) $(LDLIBS) $(TERMLIBS)

pgnuplot.exe: $(W)/pgnuplot.c version.$(O)
	$(CC) -O2 -s -DWINDOWS_NO_GUI -DHAVE_STDBOOL_H -o $@ \
		$(W)/pgnuplot.c version.$(O) -I$(W) -I$(S) -luser32


# Rules:

wgplt_res.$(O):  $(W)/wgnuplot.rc $(W)/wgnuplib.rc $(W)/wresourc.h $(W)/texticon.ico $(W)/grpicon.ico
	$(RC) $(RCFLAGS) $(W)/wgnuplot.rc $(RCOUT) --include-dir=win
	$(RES2COFF)

show.$(O): show.c plot.h setshow.h
	$(CC) -c $(CFLAGS) -DHELPFILE=\"$(HELPFILE)\" -DBINDIR=\"$(bindir)\" $<

term.$(O): term.c term.h plot.h setshow.h bitmap.h $(CORETERM)
	$(CC) -c $(CFLAGS) $(TERMFLAGS) $<

ifndef RELEASE
VERSIONING = timestamp.h
timestamp.h: $(TOP)/ChangeLog
	@echo Creating $@
	@echo "#ifndef GNUPLOT_TIMEBASE_H_INCLUDED" >$@t
	@echo "#define GNUPLOT_TIMEBASE_H_INCLUDED" >>$@t
	@head -1 $< | sed -e 's,\(^[0-9-]* \).*$$,const char gnuplot_date[] = "\1";,' >>$@t
	@echo "#endif /* GNUPLOT_TIMEBASE_H_INCLUDED */" >> $@t
	@if cmp -s $@ $@t; then rm -f $@t; else mv $@t $@; fi
else
VERSIONING = 
$(S)/version.c: $(TOP)/VERSION $(TOP)/PATCHLEVEL $(TOP)/ChangeLog $(S)/Makefile.maint
	$(MAKE) -C $(S) srcdir=. top_srcdir=.. -f Makefile.maint version.c
endif

version.$(O): version.c  $(VERSIONING)

WINDEPS = $(W)/wgnuplib.h $(W)/wcommon.h $(W)/wresourc.h

winmain.$(O): $(W)/winmain.c $(W)/wgnuplib.h $(W)/wtext.h plot.h
	$(CC) -c $(CFLAGS) -DHELPFILE=\"$(HELPFILE)\"  $(W)/winmain.c

wgnuplib.$(O): $(W)/wgnuplib.c $(WINDEPS)
	$(CC) -c $(CFLAGS) $(W)/wgnuplib.c

wmenu.$(O): $(W)/wmenu.c $(WINDEPS)
	$(CC) -c $(CFLAGS) $(W)/wmenu.c

wtext.$(O): $(W)/wtext.c $(WINDEPS)
	$(CC) -c $(CFLAGS) $(W)/wtext.c

wpause.$(O): $(W)/wpause.c $(WINDEPS)
	$(CC) -c $(CFLAGS) $(W)/wpause.c

wprinter.$(O): $(W)/wprinter.c $(WINDEPS)
	$(CC) -c $(CFLAGS) $(W)/wprinter.c

wgraph.$(O): $(W)/wgraph.c $(WINDEPS)
	$(CC) -c $(CFLAGS) $(W)/wgraph.c

screenbuf.$(O): $(W)/screenbuf.c $(WINDEPS)
	$(CC) -c $(CFLAGS) $(W)/screenbuf.c

wgnuplot.mnu: $(W)/wgnuplot.mnu
	$(CP) $^ $@


#make binary demo files
$(M)bf_test.exe : bf_test.c
	$(LD) $(LDFLAGS) $(CFLAGS) -DWINDOWS_NO_GUI -o $@ $^
	(cd $(M) ; ./bf_test.exe )


#
# Create config.h
#
$(OBJS) $(WINOBJS): config.h
config.h: $(TOP)/config/config.cyg
	cp -p $< $@

# Create documentation in various formats
#
ALL_TERMINALS_DOC=1
ifdef ALL_TERMINALS_DOC
# Generate TeX documentation with the complete list of all terminals
# (gnuplot.tex should be the same on all platforms):
SORT_TERMINALS=1
ifdef SORT_TERMINALS
# sort alphabetically all terminals (note: req. GNU sort, not from MS)
allterm.h: $(CORETERM)
	@echo "Building allterm.h"
	@for e in `egrep "^[ 	]*START_HELP" $(CORETERM) |\
	     $(GNUSORT) -f -t':' -k2` ; do \
	  f=`echo $$e |cut -d\: -f1` ; s=`echo $$e | cut -d\: -f2` ;\
	  sed -n "/^[ 	]*$$s/,/^[ 	]*END_HELP/p" $$f ; \
	done >$@
else
# sequence of terminals according to "ls term/*.trm":
allterm.h: $(CORETERM)
	@echo "Building allterm.h"
	@cat $(T)*.trm > allterm.c
	$(CPP) $(CFLAGS) -I$(T) -DTERM_DRIVER_H -DTERM_HELP allterm.c | \
	  sed '/^ *$$/d;/^#/d' > allterm.h
	@rm -f allterm.c
endif
doc2tex.exe: $(D)doc2tex.c $(D)termdoc.c allterm.h
	$(LD) $(LDFLAGS) -o $@ -DWINDOWS_NO_GUI -DALL_TERM_DOC $(CFLAGS) -I. -I$(D) -I$(T) $(D)doc2tex.c $(D)termdoc.c
else
# Old version: generate documentation with only currently used terminals:
doc2tex.exe: $(D)doc2tex.c $(D)termdoc.c
	$(LD) $(LDFLAGS) -o $@ -DWINDOWS_NO_GUI $(CFLAGS) -I. -I$(D) -I$(T) $^
endif

gnuplot.tex: $(D)gnuplot.doc doc2tex.exe
	./doc2tex $(D)gnuplot.doc gnuplot.tex

# Call LaTeX three times to get the toc right.
gnuplot.dvi: gnuplot.tex $(D)titlepag.tex
	cp gnuplot.tex $(D)gp_tex2.tex
	cp $(TOP)/VERSION $(D)
	cd $(D) && latex gp_tex2.tex && latex gp_tex2.tex && latex gp_tex2.tex
	mv $(D)gp_tex2.dvi gnuplot.dvi
	rm -f $(D)gp_tex2.*
gnuplot.ps: gnuplot.dvi
	dvips -o gnuplot.ps gnuplot.dvi
gnuplot.pdf: gnuplot.tex $(D)titlepag.tex
	cp gnuplot.tex $(D)gp_tex2.tex
	cp $(TOP)/VERSION $(D)
	cd $(D) && pdflatex gp_tex2.tex && pdflatex gp_tex2.tex \
	 	&& pdflatex gp_tex2.tex
	mv $(D)gp_tex2.pdf gnuplot.pdf
	rm -f $(D)gp_tex2.*


# clean up temporary files
clean:
	$(RM) config.h *.$(O) wgnuplot.map wgnuplot.res 
	$(RM) $(W)/wgnuplib.res wgnuplib.map wgnuplot.lib
	$(RM) $(M)bf_test.exe allterm.h allterm.c
	$(RM) gnuplot.tex gnuplot.dvi gnuplot.ps gnuplot.pdf

realclean: veryclean
veryclean: clean
	$(RM) wgnuplot.exe wgnuplot_pipes.exe gnuplot.exe
	$(RM) $(HELPFILE) wgnuplot.gid wgnuplot.mnu
	$(RM) $(M)binary[123] $(M)fit.log $(M)soundfit.par

# now move the whole stuff to its destination
install: default
	mkdir -p $(DESTDIR)
	cp gnuplot.exe $(DESTDIR)
	cp wgnuplot.exe $(DESTDIR)
	cp wgnuplot_pipes.exe $(DESTDIR)
	cp $(W)/wgnuplot.mnu $(DESTDIR)
	cp $(HELPFILE) $(DESTDIR)
	mkdir -p $(DESTDIR)/$(GNUPLOT_PS_DIR)
	cp $(T)PostScript/*.ps $(DESTDIR)/$(GNUPLOT_PS_DIR)
	mkdir -p $(DESTDIR)/$(GNUPLOT_LUA_DIR)
	cp $(T)lua/* $(DESTDIR)/$(GNUPLOT_LUA_DIR)
	mkdir -p $(DESTDIR)/$(GNUPLOT_JS_DIR)
	cp $(T)js/* $(DESTDIR)/$(GNUPLOT_JS_DIR)

=== config/msvc/Makefile ===
#
# $Id: Makefile,v 1.28.2.3 2017/07/31 02:02:24 sfeam Exp $
#
# GNUPLOT Makefile Microsoft Visual C++ 2005 or newer

# John Bollinger bbands@yahoo.com, 4 March 2002:
#   Added png support with zlib and libpng as subs of .\src
#     libpng and zlib can be downloaded from ftp://ftp.uu.net/graphics/png
#   Added pdf support with pdflib as a sub of .\src
#     pdflib can be downloaded from http://www.pdflib.com
#   Added MSC multi-thread support for compatibility with pdflib
# Bastian Maerkisch bmaerkisch@web.de:
#   Added support for binary version of the GD library (bgd.dll)
#     gdlib can be downloaded from http://www.libgd.org/
#     Development of libgd seems to have stalled:
#     Latest binary build can be found at http://www.libgd.org/releases/gd-latest-win32.zip
#     As of March 2011 this is version 2.0.34.
#   Removed zlib and libpng again as they're already included in bgd.dll
# Hans-Bernhard Broeker:
#   updated to current version of MSVC
#   undid silly name change for pgnuplot.exe, call console version gnuplot.exe instead
#   removed remainder of wgnuplot_pipes.exe support
#   isolated more configuration-dependent parts (gd, pdf, wx) to lines of their own,
#     so they can be turned on/off more easily.
# Bastian Maerkisch bmaerkisch@web.de:
#   Out of tree version. Moved to config\msvc
#   See ChangeLog for further changes.

#
# To compile with Visual C:
#	Optionally download gdlib to config\msvc\gdwin32
#	Optionally download pdflib to config\msvc\pdflib and compile it if you choose the source
#
#	Start the Microsoft Visual C++ command shell (e.g. via link installed setup)
#	change to the gnuplot\config\msvc directory
#   Edit the Makefile to match your setup. (If you don't have the optional libraries,
#   you will probably have to disable some parts.)
#	Now run:
#	  nmake
#

# Compilation options, disable by setting to zero
# Is libgd available? (required by terminal png/jpeg/gif)?
GDLIB = 0
# Is pdflib available? (required by terminal pdf)
PDFLIB = 0
# Build wxt terminal? (requires GTK, wxWidgets, cairo and pango libraries)
# See http://wiki.wxwidgets.org/Microsoft_Visual_C%2B%2B_Guide
#     http://wiki.wxwidgets.org/Visual_Studio_2008_%289.0%29
WXT = 0
# Build Cairo Terminals (cairolatex, epslatex, pdflatex)
CAIRO = 0
# Build qt terminal?
QT = 0
# Set to one if you have Qt5 (instead of Qt4)
QT5 = 1
# Build the lua/tikz terminal?
LUA = 0
# Build caca terminal? Requires libcaca
# Requires libcaca version 0.99.beta15 or newer. A post-beta18
# svn version is recommended since it contains an improved
# win32 backend.
CACA = 0

# Create debug build?
DEBUG = 0

# Location of additional libraries
#GDDIR = gdwin32
#LUADIR = lua
PDFDIR = pdflib
#QTDIR = C:\Qt\4.8.4
QTDIR = C:\Qt\5.8\msvc2015_64
#CAIRODIR = cairo-pango
#CACADIR = libcaca
CAIRODIR = d:\msvc-libs
LIBDIR =  d:\msvc-libs


# installation directory
DESTDIR = "$(PROGRAMFILES)\gnuplot"

TOP = ..\..

# directory for PostScript prolog and associated files
GNUPLOT_PS_DIR = share\\PostScript

# Similarly for javascript files for the canvas terminal:
GNUPLOT_JS_DIR = share\\js

# Similarly for scripts used by the lua terminal
GNUPLOT_LUA_DIR = share\\lua

# directory for Qt translation files
GNUPLOT_QT_DIR = share\\qt

# gnuplot will look for gnuplotrc here:
GNUPLOT_SHARE_DIR = share

#CC = cl
LD = link

# compiler flags
# /I  means extra include directory
# /Fm means produce link map
# /Od means suppress optimizations (esp. for debug)
# /O2 means optimize for speed
# /Zi means prepare for codeview
# /MD means include multi-thread support (DLL)
# /GR means Enable Run-Time Type Information
!IF "$(DEBUG)" == "1"
CBASEFLAGS = /EHsc /GR /MDd /Od /nologo /Zi
!ELSE
CBASEFLAGS = /EHsc /GR /MD /O2 /nologo
!ENDIF
CFLAGS = $(CBASEFLAGS) /I. /I$(TOP) /I$(S) /I$(T) /D_Windows /DWIN32 /DHAVE_CONFIG_H /D__MSC__ $(OPTIONS)
CFLAGS = $(CFLAGS) /DUNICODE /D_UNICODE
CFLAGS = $(CFLAGS) /DGNUPLOT_SHARE_DIR=\"$(GNUPLOT_SHARE_DIR)\"
WIN_CFLAGS =
CONSOLE_CFLAGS = /DWGP_CONSOLE
OPTIONS = /DUSE_MOUSE /DPIPES
OPTIONS = $(OPTIONS) /DGNUPLOT_HISTORY

EXTRA_TARGETS =

VERSION_CPPFLAGS = -DVERSION_MAJOR=\"5.2\" -DPATCHLEVEL=\"0\"

# flags for terminals
# see other terminal defines in term.h
TERMFLAGS = /I$(T) /DGNUPLOT_PS_DIR=\"$(GNUPLOT_PS_DIR)\" /DGNUPLOT_JS_DIR=\"$(GNUPLOT_JS_DIR)\"

# linker flags, append paths for external libs later
LDFLAGS = /nologo /MACHINE:$(MACHINE)
LDFLAGS = $(LDFLAGS) /MANIFEST:EMBED /MANIFESTINPUT:$(W)$(MANIFEST)
!IF "$(DEBUG)" == "1"
LDFLAGS = $(LDFLAGS) /DEBUG
!ENDIF
COMMONLIBS = kernel32.lib user32.lib gdi32.lib winspool.lib \
             comdlg32.lib comctl32.lib advapi32.lib shell32.lib \
             msimg32.lib gdiplus.lib shlwapi.lib \
             d2d1.lib dwrite.lib ole32.lib
CONSOLELIBS = ole32.lib oleaut32.lib comctl32.lib

!IFDEF LIBDIR
OPTIONS = $(OPTIONS) /I$(LIBDIR)\include
LDFLAGS = $(LDFLAGS) /libpath:$(LIBDIR)\lib
!ENDIF

!IF "$(GDLIB)" == "1"
OPTIONS = $(OPTIONS) /DHAVE_LIBGD /DHAVE_GD_H /DHAVE_GD_GIF /DGIF_ANIMATION /DHAVE_GD_PNG /DHAVE_GD_JPEG /DHAVE_GD_TTF
!IFDEF GDDIR
OPTIONS = $(OPTIONS) /I$(GDDIR)\include
LDFLAGS = $(LDFLAGS) /libpath:$(GDDIR)\lib
!ENDIF
!ENDIF

!IF "$(PDFLIB)" == "1"
OPTIONS = $(OPTIONS) /DHAVE_LIBPDF
!IFDEF PDFDIR
LDFLAGS = $(LDFLAGS) /libpath:$(PDFDIR)\pdflib
TERMFLAGS = $(TERMFLAGS) /I$(PDFDIR)\pdflib
!ENDIF
!ENDIF

!IF ("$(CAIRO)" == "1") || ("$(WXT)" == "1")
CAIROLIBS = glib-2.0.lib gobject-2.0.lib gmodule-2.0.lib \
	cairo.lib pango-1.0.lib pangocairo-1.0.lib
CFLAGS = $(CFLAGS) /DHAVE_CAIROPDF
TERMFLAGS = $(TERMFLAGS) /DHAVE_CAIROEPS
!IFDEF CAIRODIR
CFLAGS = $(CFLAGS) /I$(CAIRODIR)\include\glib-2.0 /I$(CAIRODIR)\lib\glib-2.0\include /I$(CAIRODIR)\include\pango-1.0 /I$(CAIRODIR)\include\msvc
!ENDIF
!ENDIF

!IF "$(WXT)" == "1"
WXTLIBS = wxmsw28.lib wxtiff.lib
!ENDIF

!IF "$(QT)" == "1"
!IF "$(DEBUG)" == "1"
!IF "$(QT5)" == "1"
QTLIBS = Qt5Cored.lib Qt5Guid.lib Qt5Networkd.lib Qt5Svgd.lib Qt5Widgetsd.lib Qt5PrintSupportd.lib qtmaind.lib
!ELSE
QTLIBS = QtCored4.lib QtGuid4.lib QtNetworkd4.lib QtSvgd4.lib
!ENDIF
!ELSE
!IF "$(QT5)" == "1"
QTLIBS = Qt5Core.lib Qt5Gui.lib Qt5Network.lib Qt5Svg.lib Qt5Widgets.lib Qt5PrintSupport.lib qtmain.lib
!ELSE
QTLIBS = QtCore4.lib QtGui4.lib QtNetwork4.lib QtSvg4.lib
!ENDIF
!ENDIF
CFLAGS = $(CFLAGS) /I$(QTDIR)\include /I$(QTDIR)\include\QtCore /I$(QTDIR)\include\QtGui /I$(QTDIR)\include\QtWidgets /I$(QTDIR)\include\QtNetwork /I$(QTDIR)\include\QtSvg /DQTGNUPLOT_DATA_DIR=\"$(GNUPLOT_QT_DIR)\"
LDFLAGS = $(LDFLAGS) /libpath:$(QTDIR)\lib
CFLAGS = $(CFLAGS) -DQTTERM -DQT_NO_OPENGL
MOC=$(QTDIR)\bin\moc
UIC=$(QTDIR)\bin\uic
RCC=$(QTDIR)\bin\rcc
EXTRA_TARGETS = $(EXTRA_TARGETS) gnuplot_qt.exe
!ENDIF

!IF "$(LUA)" == "1"
OPTIONS = $(OPTIONS) /DHAVE_LUA
!IFDEF LUADIR
OPTIONS = $(OPTIONS) /I$(LUADIR)/include
LDFLAGS = $(LDFLAGS) /libpath:$(LUADIR)
!ENDIF
TERMFLAGS = $(TERMFLAGS) /DGNUPLOT_LUA_DIR=\"$(GNUPLOT_LUA_DIR)\"
LUALIBS = lua52.lib
!ENDIF

!IF "$(CACA)" == "1"
OPTIONS = $(OPTIONS) /DHAVE_LIBCACA 
!IFDEF CACADIR
OPTIONS = $(OPTIONS) /I$(CACADIR)
LDFLAGS = $(LDFLAGS) /libpath:$(CACADIR)
!ENDIF
CACALIBS = libcaca.lib
!ENDIF

HELPFILE = wgnuplot.chm
!IF "$(PLATFORM)" == "X64"
HHC=""%%PROGRAMFILES(X86)%%\HTML Help Workshop\hhc""
!ELSE
HHC="$(PROGRAMFILES)\HTML Help Workshop\hhc"
!ENDIF

!IF "$(PROCESSOR_ARCHITECTURE)" == "ALPHA"
MACHINE = $(PROCESSOR_ARCHITECTURE)
!ELSE
!IF "$(PLATFORM)" == "X64"
MACHINE = X64
MANIFEST = wgnuplot.exe.manifest64
!ELSE
MACHINE = IX86
MANIFEST = wgnuplot.exe.manifest
!ENDIF
!ENDIF

# macros for makefile.all

O=obj
S=$(TOP)\src
W=$(S)\win\\
WX=$(S)\wxterminal\\
Q=$(S)\qtterminal\\
T=$(TOP)\term\\
D=$(TOP)\docs\\
M=$(TOP)\demo\\

default: wgnuplot.exe $(HELPFILE) wgnuplot.mnu $(M)bf_test.exe gnuplot.exe demo_plugin.dll $(EXTRA_TARGETS)

!INCLUDE $(S)\makefile.all

OBJS = $(COREOBJS) version.obj

!IF "$(CAIRO)" == "1"
OBJS = $(OBJS) gp_cairo.$(O) gp_cairo_helpers.$(O)
!ENDIF

!IF "$(QT)" == "1"
OBJS = $(OBJS) qt_term.$(O)
GNUPLOTQTOBJS = gnuplot_qt.$(O) QtGnuplotWindow.$(O) \
QtGnuplotApplication.$(O) QtGnuplotWidget.$(O) \
QtGnuplotScene.$(O) QtGnuplotItems.$(O) \
QtGnuplotEvent.$(O) \
moc_QtGnuplotWindow.$(O) moc_QtGnuplotApplication.$(O) \
moc_QtGnuplotWidget.$(O) moc_QtGnuplotScene.$(O) \
moc_QtGnuplotEvent.$(O) qrc_QtGnuplotResource.$(O)

# Call the Qt resource compiler
qrc_QtGnuplotResource.cpp: $(Q)QtGnuplotResource.qrc
	$(RCC) -name QtGnuplotResource -o $@ $**

# Call the Qt ui compiler
ui_QtGnuplotSettings.h: $(Q)QtGnuplotSettings.ui
	$(UIC) -o $@ $**

moc_QtGnuplotWindow.cpp: $(Q)QtGnuplotWindow.h
	$(MOC) -o $@ $**

moc_QtGnuplotApplication.cpp: $(Q)QtGnuplotApplication.h
	$(MOC) -o $@ $**

moc_QtGnuplotWidget.cpp: $(Q)QtGnuplotWidget.h
	$(MOC) -o $@ $**

moc_QtGnuplotScene.cpp: $(Q)QtGnuplotScene.h
	$(MOC) -o $@ $**

moc_QtGnuplotEvent.cpp: $(Q)QtGnuplotEvent.h
	$(MOC) -o $@ $**

gnuplot_qt.exe: ui_QtGnuplotSettings.h $(GNUPLOTQTOBJS)
	$(LD) /entry:mainCRTStartup /subsystem:windows $(LDFLAGS) /map:gnuplot_qt.map /out:$@ $(GNUPLOTQTOBJS) $(QTLIBS) shell32.lib user32.lib
!ENDIF

WINOBJS = winmain.obj wgnuplib.obj wgraph.obj wprinter.obj wtext.obj \
	screenbuf.obj wpause.obj wmenu.obj gpexecute.obj wgdiplus.obj \
	wd2d.obj wredirect.obj

ALL_CONSOLE_OBJS = $(OBJS:.obj=.cobj) $(WINOBJS:.obj=.cobj)


# default rules
.cpp.obj:
	$(CC) /c $(CFLAGS) $(WIN_CFLAGS) $*.cpp /Fo$@

.cpp.cobj:
	$(CC) /c $(CFLAGS) $(CONSOLE_CFLAGS) $*.cpp /Fo$@

{$(S)}.c.obj:
	$(CC) /c $(CFLAGS) $(WIN_CFLAGS) $(S)\$*.c

{$(S)}.c.cobj:
	$(CC) /c $(CFLAGS) $(CONSOLE_CFLAGS) $(S)\$*.c /Fo$@

{$(W)}.c.obj:
	$(CC) /c $(CFLAGS) $(WIN_CFLAGS) $(W)$*.c /Fo$@

{$(W)}.c.cobj:
	$(CC) /c $(CFLAGS) $(CONSOLE_CFLAGS) $(W)$*.c /Fo$@

{$(W)}.cpp.obj:
	$(CC) /c $(CFLAGS) $(WIN_CFLAGS) $(W)$*.cpp /Fo$@

{$(W)}.cpp.cobj:
	$(CC) /c $(CFLAGS) $(CONSOLE_CFLAGS) $(W)$*.cpp /Fo$@

{$(WX)}.c.obj:
	$(CC) /c $(CFLAGS) $(WIN_CFLAGS) $(WX)$*.c /Fo$@

{$(WX)}.c.cobj:
	$(CC) /c $(CFLAGS) $(CONSOLE_CFLAGS) $(WX)$*.c /Fo$@

{$(Q)}.cpp.obj:
	$(CC) /c $(CFLAGS) $(WIN_CFLAGS) $(Q)$*.cpp /Fo$@

{$(Q)}.cpp.cobj:
	$(CC) /c $(CFLAGS) $(CONSOLE_CFLAGS) $(Q)$*.cpp /Fo$@

{$(S)}.c{$(M)}.exe:
	$(CC) /c $(CFLAGS) $(W)$*.c /Fo$@


$(OBJS): config.h

config.h: $(TOP)\config\config.nt
	copy $(TOP)\config\config.nt config.h

wgnuplot.exe: $(OBJS) $(WINOBJS) wgnuplot.res linkopt-w.msw
	$(LD) /subsystem:windows $(LDFLAGS) /map:wgnuplot.map /out:$@ @linkopt-w.msw
!IFDEF GDDIR
	copy $(GDDIR)\bin\*.dll .
!ENDIF
!IFDEF LUADIR
	copy $(LUADIR)\*.dll .
!ENDIF
!IFDEF CACADIR
	copy $(CACADIR)\*.dll .
!ENDIF

gnuplot.exe: $(ALL_CONSOLE_OBJS) wgnuplot.res linkopt-c.msw
	$(LD) /subsystem:console $(LDFLAGS) /map:wgnuplot.map /out:$@ @linkopt-c.msw
!IFDEF GDDIR
	copy $(GDDIR)\bin\*.dll .
!ENDIF
!IFDEF LUADIR
	copy $(LUADIR)\*.dll .
!ENDIF
!IFDEF CACADIR
	copy $(CACADIR)\*.dll .
!ENDIF

pgnuplot.exe: $(W)pgnuplot.c
	$(CC) $(CBASEFLAGS) /I. /I$(TOP) /I$(S) /DWINDOWS_NO_GUI $(W)pgnuplot.c /Fe$@ /link version.obj user32.lib

linkopt-w.msw: Makefile
	echo $(OBJS) > linkopt-w.msw
	echo $(WINOBJS) >> linkopt-w.msw
	echo $(COMMONLIBS) >> linkopt-w.msw
	echo wgnuplot.res >> linkopt-w.msw
	echo htmlhelp.lib >> linkopt-w.msw
!IF "$(GDLIB)" == "1"
	echo bgd.lib >> linkopt-w.msw
!ENDIF
!IF "$(PDFLIB)" == "1"
	echo pdflib.lib >> linkopt-w.msw
!ENDIF
!IF "$(CAIRO)" == "1"
	echo $(CAIROLIBS) >> linkopt-w.msw
!ENDIF
!IF "$(WXT)" == "1"
	echo $(WXTLIBS) >> linkopt-w.msw
!ENDIF
!IF "$(QT)" == "1"
	echo $(QTLIBS) >> linkopt-w.msw
!ENDIF
!IF "$(LUA)" == "1"
	echo $(LUALIBS) >> linkopt-w.msw
!ENDIF
!IF "$(CACA)" == "1"
	echo $(CACALIBS) >> linkopt-w.msw
!ENDIF

linkopt-c.msw: Makefile
	echo $(ALL_CONSOLE_OBJS) > linkopt-c.msw
	echo $(COMMONLIBS) >> linkopt-c.msw
	echo $(CONSOLELIBS) >> linkopt-c.msw
	echo wgnuplot.res >> linkopt-c.msw
	echo htmlhelp.lib >> linkopt-c.msw
!IF "$(GDLIB)" == "1"
	echo bgd.lib >> linkopt-c.msw
!ENDIF
!IF "$(PDFLIB)" == "1"
	echo pdflib.lib >> linkopt-c.msw
!ENDIF
!IF "$(CAIRO)" == "1"
	echo $(CAIROLIBS) >> linkopt-c.msw
!ENDIF
!IF "$(WXT)" == "1"
	echo $(WXTLIBS) >> linkopt-c.msw
!ENDIF

=== config/watcom/Makefile ===
# Hello, emacs: this is a -*- Makefile -*-
# $Id: Makefile,v 1.17.2.3 2017/08/29 13:20:16 markisch Exp $
#
# GNUPLOT Makefile OpenWatcom 1.3 on Win32

# To compile:
#       Either, from ..\src:
#         wmake -f ..\config\makefile.oww
#       or copy this file to ..\src, edit it to your liking, then
#       from ..\src:
#         wmake -f makefile.oww
# 
# History of this file:
# 2004-02-23: Created by massive editing of makefile.nt (and config.nt)
# 2004-04-25: Removed all remaining MS-isms (by peeking at how OW's
#  MS namesake replacement tools generate their command lines)
#

# enable exactly one of these:
VARIANT = PLAIN
#VARIANT = PIPES
#VARIANT = CONSOLE

TOP = ..\..

# Programs: 
# The Microsoft Help compiler:
HCW = "c:\program files\help workshop\hcw.exe"
# ... and the HTML help compiler
HHC_DIR = c:\Program Files\HTML Help Workshop
HHC = "$(HHC_DIR)\hhc.exe"

# OpenWatcom programs:
WCL = wcl386
WCC = wcc386
WPP = wpp386
WLD = wlink
WRC = wrc

# Speed up compilation a bit by running the compiler as a DLL from
# inside wmake:
!ifdef __LOADDLL__
!  loaddll wcc      wccd
!  loaddll wccaxp   wccdaxp
!  loaddll wcc386   wccd386
!  loaddll wpp      wppdi86
!  loaddll wppaxp   wppdaxp
!  loaddll wpp386   wppd386
!  loaddll wlink    wlinkd
!  loaddll wlib     wlibd
!endif

# Where to install the PostScript prologue files, relatively to the executable
# wgnuplot.exe
GNUPLOT_PS_DIR = share/PostScript

# paths for external libs added here... 
LDLIBS = 

# Optional libraries:
# GDI+ and Direct2D/DirectWrite support libraries are available at
#   https://sourceforge.net/p/gnuplot/patches/746/
#GDIPLUS=1
#DIRECT2D=1

# Macros for makefile.all
O=obj
T=$(TOP)\term\
D=$(TOP)\docs\
M=$(TOP)\demo\
S=$(TOP)\src
W=$(S)\win

BINARYFILES=$(M)binary1 $(M)binary2 $(M)binary3

# compiler flags: 
#
# Defines

CPPFLAGS =  -DHAVE_CONFIG_H -D_Windows -DHAVE_CONFIG_H -DUSE_MOUSE -DEAM_OBJECTS
CPPFLAGS += -DVERSION_MAJOR="5.2" -DPATCHLEVEL="0"
CPPFLAGS += -DUNICODE -D_UNICODE
# library-dependent ones may have to be added, like:
# -DHAVE_LIBPNG -DHAVE_LIBPDF
!ifdef GDIPLUS
CPPFLAGS += -DHAVE_GDIPLUS
!endif
!ifdef DIRECT2D
CPPFLAGS += -DHAVE_D2D
!endif

HELPFILE = wgnuplot.chm

DEFAULT_TARGETS = $(BINARYFILES) $(HELPFILE)

TARGETS_PLAIN=wgnuplot.exe wgnuplot.mnu
EXTRA_CPPFLAGS_PLAIN = -DUSE_FAKEPIPES

TARGETS_PIPES=wgnuplot_pipes.exe wgnuplot.mnu
EXTRA_CPPFLAGS_PIPES = 

TARGETS_CONSOLE=gnuplot.exe
EXTRA_CPPFLAGS_CONSOLE = -DWGP_CONSOLE

ALL_TARGETS = $(DEFAULT_TARGETS) $(TARGETS_PLAIN) $(TARGETS_PIPES) $(TARGETS_CONSOLE)

DEFAULT_TARGETS += $(TARGETS_$(VARIANT))

LDLIBS += LIBRARY htmlhelp.lib
!ifdef GDIPLUS
LDLIBS += LIBRARY gdiplus.lib
!endif
!ifdef DIRECT2D
LDLIBS += LIBRARY d2d1.lib LIBRARY dwrite.lib
!endif

# compiler flags, determined from MS ones by OW's "cl /showwopts"

# -c  : don't link
# -I  : add directory to include search path
# -zq : don't show a version banner message
# -5r : P5-optimized, 386-compatible code, register calling convention
# -zm : put each function in its own section to improve dead code elimination
# -bm : target multi-threaded environment
# -sg : grow the stack if needed
# -zlf: store library usage in .obj files
# -ei : force sizeof(enum) >= sizeof(int)
# -o  : optimization options:   
#    r:   reorder for pipelining
#    i:   inline intrinsics
#    l:   loop optimizations
#    t:   optimize for speed
# -j  : char is signed
# -aa : allow non-const initializers for locals
# -d2 : debug information
WCFLAGS = -zlf -ei -zq -I$(S);$(W) -zm -bm -5r -sg -orilt -aa -d2 $(CPPFLAGS) $(OPTS)
WPPFLAGS = -zlf -ei -zq -I$(S);$(W) -zm -bm -5r -sg -orilt -d2 $(CPPFLAGS) $(OPTS)
# removed: -za99

# ...and here.
# see other terminal defines in term.h
TERMFLAGS = -DGNUPLOT_PS_DIR="$(GNUPLOT_PS_DIR)" -I$(T)

# Note: like makefile.wc, this need the special Watcom-style version of
# makefile.all, because line continuation in WMake is different...
!INCLUDE $(S)\makefile.awc

default: $(DEFAULT_TARGETS) .SYMBOLIC

all: $(ALL_TARGETS) .SYMBOLIC

WINOBJS = winmain.$(O) wgnuplib.$(O) wgraph.$(O) wprinter.$(O) wtext.$(O) &
          wpause.$(O) wmenu.$(O) gpexecute.$(O) screenbuf.$(O)
!ifdef GDIPLUS
WINOBJS = $(WINOBJS) wgdiplus.$(O)
!endif
!ifdef DIRECT2D
WINOBJS = $(WINOBJS) wd2d.$(O)
!endif

OBJS = $(COREOBJS) version.$(O) $(WINOBJS)

O=cobj
CONSOLE_OBJS = $+ $(OBJS) $-
O=pobj
PIPE_OBJS = $+ $(OBJS) $-
O=obj

WIN_EXTRA_INPUTS = wgnuplot.res

# extensions:
.EXTENSIONS:
.EXTENSIONS: .exe .cobj .pobj .obj .asm .pas .c .cpp .for

.c: $(S);$(W)
.cpp: $(S);$(W)

# default rule
.c.obj: .AUTODEPEND
	$(WCC) $(EXTRA_CPPFLAGS_PLAIN) $(WCFLAGS) $[@

.c.cobj: .AUTODEPEND
	$(WCC) $(EXTRA_CPPFLAGS_CONSOLE) $(WCFLAGS) $[@ -fo=$^@

.c.pobj: .AUTODEPEND
	$(WCC) $(EXTRA_CPPFLAGS_PIPES) $(WCFLAGS) $[@ -fo=$^@

.cpp.obj: .AUTODEPEND
	$(WPP) $(EXTRA_CPPFLAGS_PLAIN) $(WPPFLAGS) $[@

.cpp.cobj: .AUTODEPEND
	$(WPP) $(EXTRA_CPPFLAGS_CONSOLE) $(WPPFLAGS) $[@ -fo=$^@

.cpp.pobj: .AUTODEPEND
	$(WPP) $(EXTRA_CPPFLAGS_PIPES) $(WPPFLAGS) $[@ -fo=$^@

# file-specific rules
wgnuplot.exe: $(OBJS) $(WIN_EXTRA_INPUTS)
        $(WLD) @<<linkopt1.oww $(LDLIBS)
RUNTIME windows=4.0
SYSTEM nt_win
DEBUG ALL
OPTION quiet
FILE {
 $(OBJS)
}
LIBRARY kernel32.lib,user32.lib,gdi32.lib,winspool.lib,comdlg32.lib
LIBRARY comctl32.lib,advapi32.lib,shell32.lib
LIBRARY msimg32.lib
LIBRARY shlwapi.lib
OPTION map
OPTION SYMFILE
NAME $^&
OPTION stack=1M
OPTION resource=wgnuplot.res
OPTION ELIMINATE
REFERENCE _wstart_ 
OPTION START=_wstart_
<<

wgnuplot_pipes.exe: $(PIPE_OBJS) $(WIN_EXTRA_INPUTS)
        $(WLD) @<<linkopt1.oww $(LDLIBS)
RUNTIME windows=4.0
SYSTEM nt_win
DEBUG ALL
OPTION quiet
FILE {
 $(PIPE_OBJS)
}
LIBRARY kernel32.lib,user32.lib,gdi32.lib,winspool.lib,comdlg32.lib
LIBRARY advapi32.lib,shell32.lib
LIBRARY msimg32.lib
LIBRARY shlwapi.lib
OPTION map
OPTION SYMFILE
NAME $^&
OPTION stack=1M
OPTION resource=wgnuplot.res
OPTION ELIMINATE
REFERENCE _wstart_ 
OPTION START=_wstart_
<<

gnuplot.exe: $(CONSOLE_OBJS) $(WIN_EXTRA_INPUTS) 
        $(WLD) @<<linkopt1.oww $(LDLIBS)
RUNTIME console=4.0
SYSTEM nt
DEBUG ALL
OPTION quiet
FILE {
 $(CONSOLE_OBJS)
}
LIBRARY kernel32.lib,user32.lib,gdi32.lib,winspool.lib,comdlg32.lib
LIBRARY advapi32.lib,shell32.lib
LIBRARY msimg32.lib
LIBRARY shlwapi.lib
OPTION map
OPTION SYMFILE
NAME gnuplot.exe
OPTION stack=1M
OPTION resource=wgnuplot.res
OPTION ELIMINATE
#REFERENCE _wstart_ 
#OPTION START=_wstart_
<<keep

# NOTE: Unknown what /l 0x409 does in MS RC call --- seems to work without, though
wgnuplot.res :  $(W)\wgnuplot.rc $(W)\wgnuplib.rc &
  $(W)\wresourc.h $(W)\texticon.ico $(W)\grpicon.ico
        $(WRC) -r -q -bt=nt -fowgnuplot.res -i=$(W) &
	   -d_WIN32 -dNDEBUG -dWIN32 $(W)\wgnuplot.rc

term.obj: $(S)\term.c $(CORETERM) .AUTODEPEND
        $(WCC) $(EXTRA_CPPFLAGS_PLAIN) $(WCFLAGS) $(TERMFLAGS) $[@
term.cobj: $(S)\term.c $(CORETERM) .AUTODEPEND
        $(WCC) $(EXTRA_CPPFLAGS_CONSOLE) $(WCFLAGS) $(TERMFLAGS) $[@ -fo=$^@
term.pobj: $(S)\term.c $(CORETERM) .AUTODEPEND
        $(WCC) $(EXTRA_CPPFLAGS_PIPES) $(WCFLAGS) $(TERMFLAGS) $[@ -fo=$^@

wgnuplot.mnu: $(W)\wgnuplot.mnu
        copy $(W)\wgnuplot.mnu wgnuplot.mnu

pgnuplot.exe: $(W)\pgnuplot.c version.$(O) .AUTODEPEND
        $(WCL) -DWINDOWS_NO_GUI -5r -zq -d2 -fm $(W)\pgnuplot.c -fe=pgnuplot.exe -I$(S) &
	  version.$(O) user32.lib


WD=$(D)windows\
HHP_PROJ=$(WD)wgnuplot.hhp
HHP_CONTENT=$(WD)wgnuplot.hhc
HHP_INPUT=$(WD)wgnuplot.html
HHP_OUTPUT=$(WD)wgnuplot.chm   

wgnuplot.chm: $(HHP_OUTPUT)
        copy $(HHP_OUTPUT) .

$(HHP_OUTPUT): $(HHP_PROJ) $(HHP_INPUT) $(HHP_CONTENT)
        -$(HHC) $(HHP_PROJ)

$(HHP_INPUT) $(HHP_CONTENT): doc2html.exe $(D)gnuplot.doc
        doc2html $(D)gnuplot.doc $(WD)

doc2html.exe: $(WD)doc2html.c $(D)termdoc.c $(D)xref.c version.$(O) .AUTODEPEND
        $(WCL) $(WCFLAGS) -w1 -DWINDOWS_NO_GUI -I$(D);$(T) -fe$^@ $(WD)doc2html.c $(D)termdoc.c $(D)xref.c version.$(O)

gnuplot.gih: doc2gih.exe $(D)gnuplot.doc
        doc2gih $(D)gnuplot.doc $^@

doc2gih.exe: $(D)doc2gih.c $(D)termdoc.c $(D)xref.c .AUTODEPEND
        $(WCL) $(EXTRA_CPPFLAGS_CONSOLE) $(WCFLAGS) -w1 -I$(D);$(T) -fe$^@ $(D)doc2gih.c $(D)termdoc.c $(D)xref.c

#make binary demo files
# WINDOWS_NO_GUI makes sure that wtext.h does not redefine fread() etc.
bf_test.exe : bf_test.c  .AUTODEPEND
        $(WCL) $(WCFLAGS) -w1 -DWINDOWS_NO_GUI -fe$^@ $(S)\bf_test.c

$(BINARYFILES): bf_test.exe
        .\bf_test
        move binary? $(M).

dbinary.$(O): $(S)\binary.c
        $(WCC) $(WCFLAGS) -w1 -DWINDOWS_NO_GUI -fodbinary.$(O) $[@

# clean up temporary files
clean: .SYMBOLIC
        rm -f *.obj *.cobj *.pobj *.err
        rm -f wgnuplot.res $(W)\gnuplot.rtf $(W)\wgnuplot.hlp
        rm -f bf_test.exe linkopt1.oww doc2html.exe
        rm -f doc2gih.exe gnuplot.gih
        rm -f *.map *.sym wgnuplot.gid        

realclean: clean .SYMBOLIC
        rm -f wgnuplot.exe wgnuplot.mnu pgnuplot.exe gnuplot.exe wgnuplot_pipes.exe
        rm -f $(HHP_CONTENT) $(HHP_INPUT) $(HHP_OUTPUT) $(WD)wgnuplot.log
        rm -f wgnuplot.hlp wgnuplot.chm wgnuplot.chw
        rm -f $(D)binary[123] $(D)fit.log $(D)soundfit.par

=== demo/html/Makefile ===
all: html showcase_plots

distclean: clean
clean:
	rm -f *.png *.gnu *.html *.dat epslatex* fit.log soundfit.par *.tmp *.js *.?.svg *.??.svg jsdir

GNUPLOT_LIB = ..

#
# Auto-generation of the html demo set using the png terminal.
#
# Several of the demos need manual intervention:
#	fontfile vector epslatex
#
html: airfoil.html approximate.html armillary.html array.html arrowstyle.html barchart_art.html binary.html bins.html bivariat.html boxplot.html boxclusters.html candlesticks.html cerf.html circles.html cities.html complex_trig.html contours.html controls.html custom_key.html dashtypes.html datastrings.html dgrid3d.html discrete.html electron.html ellipse.html enhanced_utf8.html epslatex.html errorbars.html fenceplot.html fillbetween.html fillcrvs.html fillstyle.html finance.html fit.html hidden.html hidden2.html histograms.html histograms2.html gantt.html image.html image2.html index.html iterate.html jitter.html layout.html lines_arrows.html linkedaxes.html margins.html monotonic_spline.html multiaxis.html multimsh.html multiplt.html nokey.html nonlinear1.html nonlinear3.html parallel.html param.html piecewise.html pm3dcolors.html pm3d.html pm3dgamma.html pm3d_lighting.html pointsize.html polar.html poldat.html prob2.html prob.html rainbow.html random.html rectangle.html rgba_lines.html rgbalpha.html rgb_variable.html rotate_labels.html rugplot.html running_avg.html scatter.html simple.html singulr.html smooth.html solar_path.html spline.html smooth_splines.html steps.html stringvar.html surface1.html surface2.html azimuth.html transparent.html transparent_solids.html textbox.html tics.html timedat.html ttics.html using.html varcolor.html vector.html violinplot.html world.html world2.html animate2.html heatmaps.html stats.html zerror.html

index.html: index.save
	cp index.save index.html
	cp ../../term/js/*.png .

circles.html: $(GNUPLOT_LIB)/hidden2.dem ./webify.pl
	export DEMOTERM="pngcairo truecolor font 'arial,8' size 500,300"; ./webify.pl circles

cities.html: $(GNUPLOT_LIB)/cities.dem ./webify.pl
	export DEMOTERM="pngcairo font 'Times,8' fontscale 2.5 size 500,500"; ./webify.pl cities

ellipse.html: random.html

hidden2.html: $(GNUPLOT_LIB)/hidden2.dem ./webify.pl
	export DEMOTERM="pngcairo font 'arial,8' size 540,384"; ./webify.pl hidden2

image.html: $(GNUPLOT_LIB)/image.dem ./webify.pl
	export DEMOTERM="pngcairo font 'arial,8' size 540,384"; ./webify.pl image

image2.html: $(GNUPLOT_LIB)/image2.dem ./webify.pl
	export DEMOTERM="pngcairo font 'arial,8' size 540,384"; ./webify.pl image2

rgbalpha.html: $(GNUPLOT_LIB)/rgbalpha.dem ./webify.pl
	export DEMOTERM="pngcairo font 'arial,8' size 540,360"; ./webify.pl rgbalpha

rgb_variable.html: $(GNUPLOT_LIB)/rgb_variable.dem ./webify.pl
	export DEMOTERM="pngcairo font 'arial,8' size 540,360"; ./webify.pl rgb_variable

rugplot.html: random.html

finance.html: $(GNUPLOT_LIB)/finance.dem ./webify.pl
	export DEMOTERM="pngcairo transparent font 'arial,8' size 660,320"; ./webify.pl finance

linkedaxes.html: $(GNUPLOT_LIB)/linkedaxes.dem ./webify.pl
	export DEMOTERM="pngcairo enhanced font 'arial,9' size 610,320"; ./webify.pl linkedaxes 


multiplt.html: $(GNUPLOT_LIB)/multiplt.dem ./webify.pl
	export DEMOTERM="pngcairo transparent font 'arial,8' size 610,480"; ./webify.pl multiplt

transparent.html: $(GNUPLOT_LIB)/transparent.dem ./webify.pl
	export DEMOTERM="pngcairo transparent truecolor font 'arial,8' size 512,280"; ./webify.pl transparent

transparent_solids.html: $(GNUPLOT_LIB)/transparent_solids.dem ./webify.pl
	export DEMOTERM="pngcairo truecolor font 'arial,9' size 512,384"; ./webify.pl transparent_solids

# The png terminal does not support dashed lines, so let's use pngcairo
lines_arrows.html: $(GNUPLOT_LIB)/lines_arrows.dem ./webify.pl
	export DEMOTERM="pngcairo dash dl 2"; ./webify.pl lines_arrows

rgba_lines.html: $(GNUPLOT_LIB)/rgba_lines.dem ./webify.pl
	export DEMOTERM="pngcairo dash dl 2"; ./webify.pl rgba_lines

complex_trig.html: $(GNUPLOT_LIB)/complex_trig.dem ./webify.pl
	export DEMOTERM="pngcairo enhanced font 'times'"; ./webify.pl complex_trig

animate2.html: $(GNUPLOT_LIB)/animate2.dem ./webify.pl
	export DEMOTERM="gif animate transparent noopt delay 10 size 200,200 background rgb 'black'"; ./webify.pl animate2
	mv animate2.html temp.html
	cat temp.html | sed -e 's/1.png/1.gif/g' > animate2.html
	mv animate2.1.png animate2.1.gif
	rm temp.html

showcase_plots: complex_trig.html pm3d_lighting.html
	cp violinplot.5.png showcase_plot_1.png
	cp pm3d_lighting.2.png showcase_plot_2.png

%.html: $(GNUPLOT_LIB)/%.dem ./webify.pl
	./webify.pl $*

=== debian/changelog ===
gnuplot (5.2.2+dfsg1-2ubuntu1) bionic; urgency=medium
 
  * Restore Provides/Breaks/Replaces needed for upgrades from xenial
    (LP: #1754577).  This can be dropped after the bionic release.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 03 Apr 2018 16:51:18 +0100

gnuplot (5.2.2+dfsg1-2) unstable; urgency=medium

  * [0bc35ea] Fix installation of non-arch files. (Closes: #881223)

 -- Anton Gladky <gladk@debian.org>  Thu, 09 Nov 2017 05:40:21 +0100

gnuplot (5.2.2+dfsg1-1) unstable; urgency=medium

  * [d1fb5bb] Update d/copyright
  * [e346cfa] Update d/watch
  * [9c49e48] New upstream version 5.2.2+dfsg1
  * [133babd] Refresh patches

 -- Anton Gladky <gladk@debian.org>  Wed, 08 Nov 2017 21:00:44 +0100

=== debian/control ===
Source: gnuplot
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>
Section: math
Priority: optional
Build-Depends: autoconf,
               automake,
               debhelper (>= 10),
               dh-lua,
               libcairo2-dev,
               libedit-dev,
               libgd-dev,
               liblua5.1-dev,
               libpango1.0-dev,
               libpng-dev,
               qtbase5-dev,
               qtbase5-dev-tools,
               qttools5-dev-tools,
               latex2html,
               libqt5webkit5-dev,
               libqt5opengl5-dev,
               libqt5svg5-dev,
               libx11-dev,
               libxt-dev,
               pkg-config,
               texinfo,
               texlive-fonts-recommended,
               texlive-font-utils,
               texlive-latex-base,
               texlive-latex-extra,
               texlive-latex-recommended,
               libwxgtk3.0-dev,
               zlib1g-dev,
               emacs25-nox | emacs25 | emacs24
Standards-Version: 4.1.1
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/gnuplot.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/gnuplot.git
Homepage: http://gnuplot.sourceforge.net/

Package: gnuplot
Architecture: all
Depends: gnuplot-qt | gnuplot-x11 | gnuplot-nox,
         ${misc:Depends}
Provides: gnuplot5
Breaks: gnuplot5 (<< 5.0.5+dfsg1-4~)
Replaces: gnuplot5 (<< 5.0.5+dfsg1-4~)
Suggests: gnuplot-doc
Description: Command-line driven interactive plotting program.
 Gnuplot is a portable command-line driven interactive data and function
 plotting utility that supports lots of output formats, including drivers
 for many printers, (La)TeX, (x)fig, Postscript, and so on. The X11-output
 is packaged in gnuplot-x11.
 .
 Data files and self-defined functions can be manipulated by the internal
 C-like language. Can perform smoothing, spline-fitting, or nonlinear fits,
 and can work with complex numbers.
 .
 This metapackage is to install a full-featured gnuplot (-qt, -x11 or -nox).

Package: gnuplot-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Breaks: gnuplot (<< 5.0.5+dfsg1-4~)
Replaces: gnuplot (<< 5.0.5+dfsg1-4~)
Description: Command-line driven interactive plotting program. Doc-package
 Gnuplot is a portable command-line driven interactive data and function
 plotting utility that supports lots of output formats, including drivers
 for many printers, (La)TeX, (x)fig, Postscript, and so on.
 .
 Data files and self-defined functions can be manipulated by the internal
 C-like language. Can perform smoothing, spline-fitting, or nonlinear fits,
 and can work with complex numbers.
 .
 This package contains the additional documentation.

Package: gnuplot-nox
Architecture: any
Depends: gnuplot-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: fonts-liberation,
            groff
Suggests: gnuplot-doc
Conflicts: gnuplot-qt,
           gnuplot-x11
Provides: gnuplot, gnuplot5-nox
Replaces: gnuplot-qt,
          gnuplot-x11,
          gnuplot5-nox (<< 5.0.5+dfsg1-4~)
Breaks: gnuplot5-nox (<< 5.0.5+dfsg1-4~)
Description: Command-line driven interactive plotting program. No-X package
 Gnuplot is a portable command-line driven interactive data and function
 plotting utility that supports lots of output formats, including drivers
 for many printers, (La)TeX, (x)fig, Postscript, and so on. The X11-output
 is packaged in gnuplot-x11. The QT-output is packaged in gnuplot-qt.
 .
 Data files and self-defined functions can be manipulated by the internal
 C-like language. Can perform smoothing, spline-fitting, or nonlinear fits,
 and can work with complex numbers.
 .
 This package is for working without an X server.

Package: gnuplot-qt
Architecture: any
Depends: gnuplot-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: gnuplot-doc
Conflicts: gnuplot-x11,
           gnuplot-nox
Provides: gnuplot-nox,
          gnuplot,
          gnuplot5-qt
Replaces: gnuplot-x11,
          gnuplot-nox,
          gnuplot5-qt (<< 5.0.5+dfsg1-4~)
Breaks: gnuplot5-qt (<< 5.0.5+dfsg1-4~)
Description: Command-line driven interactive plotting program. QT-package
 Gnuplot is a portable command-line driven interactive data and function
 plotting utility that supports lots of output formats, including drivers
 for many printers, (La)TeX, (x)fig, Postscript, and so on.
 .
 Data files and self-defined functions can be manipulated by the internal
 C-like language. Can perform smoothing, spline-fitting, or nonlinear fits,
 and can work with complex numbers.
 .
 This package contains the terminal driver that enables gnuplot to plot
 images interactively using Qt.
 .
 The package provides gnuplot-x11 and gnuplot-nox terminals plus an
 additional QT-terminal for output.

Package: gnuplot-x11
Architecture: any
Depends: gnuplot-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: gnuplot-doc
Conflicts: gnuplot-qt,
           gnuplot-nox
Provides: gnuplot-nox,
          gnuplot,
          gnuplot5-x11
Replaces: gnuplot-qt,
          gnuplot-nox,
          gnuplot5-x11 (<< 5.0.5+dfsg1-4~)
Breaks: gnuplot5-x11 (<< 5.0.5+dfsg1-4~)
Description: Command-line driven interactive plotting program. X-package
 Gnuplot is a portable command-line driven interactive data and function
 plotting utility that supports lots of output formats, including drivers
 for many printers, (La)TeX, (x)fig, Postscript, and so on.
 .
 Data files and self-defined functions can be manipulated by the internal
 C-like language. Can perform smoothing, spline-fitting, or nonlinear fits,
 and can work with complex numbers.
 .
 This package contains the terminal driver that enables gnuplot to plot
 images interactively under X11.

Package: gnuplot-data
Architecture: all
Section: doc
Depends: aglfn,
         ${misc:Depends}
Breaks: gnuplot5-data,
        gnuplot-tex (<< 4.6.6-4)
Replaces: gnuplot5-data,
          gnuplot-tex (<< 4.6.6-4)
Description: Command-line driven interactive plotting program. Data-files
 Gnuplot is a portable command-line driven interactive data and function
 plotting utility that supports lots of output formats, including drivers
 for many printers, (La)TeX, (x)fig, Postscript, and so on. The X11-output
 is packaged in gnuplot-x11.
 .
 Data files and self-defined functions can be manipulated by the internal
 C-like language. Can perform smoothing, spline-fitting, or nonlinear fits,
 and can work with complex numbers.
 .
 This package contains data-files which are used by -nox, -x11 and -qt.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

export DEB_BUILD_MAINT_OPTIONS := hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# Tell compiler where should find lua headers
export DEB_CFLAGS_MAINT_APPEND = -I/usr/include/lua5.1

# Force the use of qt5
export QT_SELECT=qt5

# Qt insists on using -fPIC
export DEB_CXXFLAGS_MAINT_APPEND = -fPIC

# For reproducible builds
export FORCE_SOURCE_DATE = 1

BUILDDIR_NOX = $(CURDIR)/debian/build-nox
BUILDDIR_X11 = $(CURDIR)/debian/build-x11
BUILDDIR_QT = $(CURDIR)/debian/build-qt
MANPNOX = $(CURDIR)/debian/gnuplot-nox/usr/share/man/man1/gnuplot-nox.1

conf_opts += \
	--prefix=/usr \
	--mandir=\$${prefix}/share/man \
	--libexecdir=\$${prefix}/lib/gnuplot \
	--datadir=\$${prefix}/share/gnuplot \
	--with-gihdir=\$${prefix}/share/gnuplot \
	--without-lasergnu \
	--with-png \
	--with-gd \
	--without-lisp-files \
	--without-linux-vga \
	--with-readline=bsd

ifneq (,$(filter $(DEB_HOST_ARCH), mips mips64el powerpc mipsel))
	conf_opts += --without-lua
endif

override_dh_auto_configure:
	mkdir -p $(BUILDDIR_NOX)
	cd $(BUILDDIR_NOX); CONFIG_SHELL=/bin/sh ./../../configure $(conf_opts) --with-qt=no --without-x --disable-wxwidgets
	mkdir -p $(BUILDDIR_X11)
	cd $(BUILDDIR_X11); CONFIG_SHELL=/bin/sh ../../configure $(conf_opts) --with-qt=no --with-tutorial
	mkdir -p $(BUILDDIR_QT)
	cd $(BUILDDIR_QT); CONFIG_SHELL=/bin/sh ../../configure $(conf_opts)  --enable-qt

override_dh_auto_build:
	dh_auto_build -a -- -C $(BUILDDIR_NOX)/src
	dh_auto_build -a -- -C $(BUILDDIR_X11) pkglibexecdir='$$(libexecdir)'
	dh_auto_build -a -- -C $(BUILDDIR_QT) pkglibexecdir='$$(libexecdir)'
	cd $(BUILDDIR_X11)/docs; $(MAKE) pdf; $(MAKE) ps; $(MAKE) html; $(MAKE) info; ls
	cd $(BUILDDIR_X11)/tutorial; $(MAKE) pdf; $(MAKE) ps; ls
	sed -i '/<ADDRESS>/,/<\/ADDRESS>/{//!d}' $(BUILDDIR_X11)/docs/htmldocs/index.html
	sed -i '/<ADDRESS>/,/<\/ADDRESS>/{//!d}' $(BUILDDIR_X11)/docs/htmldocs/figures.html
	rm -f $(BUILDDIR_X11)/docs/htmldocs/internals.pl
	rm -f $(BUILDDIR_X11)/docs/htmldocs/labels.pl
	rm -f $(BUILDDIR_X11)/docs/htmldocs/images.log
	rm -f $(BUILDDIR_X11)/docs/htmldocs/WARNINGS
	rm -f $(BUILDDIR_X11)/docs/gpcard.ps

override_dh_auto_install:
	$(MAKE) -C $(BUILDDIR_NOX) install DESTDIR=$(CURDIR)/debian/tmp/NOX/ \
		pkglibexecdir='$$(libexecdir)'
	mv $(CURDIR)/debian/tmp/NOX/usr/bin/gnuplot $(CURDIR)/debian/tmp/NOX/usr/bin/gnuplot-nox
	mv $(CURDIR)/debian/tmp/NOX/usr/share/man/man1/gnuplot.1 $(CURDIR)/debian/tmp/NOX/usr/share/man/man1/gnuplot-nox.1
	mv $(CURDIR)/debian/tmp/NOX/usr/share/gnuplot/gnuplot.gih $(CURDIR)/debian/tmp/NOX/usr/share/gnuplot/gnuplot-nox.gih
	$(MAKE) -C $(BUILDDIR_X11) install DESTDIR=$(CURDIR)/debian/tmp/X11/ \
		pkglibexecdir='$$(libexecdir)'
	mv $(CURDIR)/debian/tmp/X11/usr/bin/gnuplot $(CURDIR)/debian/tmp/X11/usr/bin/gnuplot-x11
	mv $(CURDIR)/debian/tmp/X11/usr/share/man/man1/gnuplot.1 $(CURDIR)/debian/tmp/X11/usr/share/man/man1/gnuplot-x11.1
	mv $(CURDIR)/debian/tmp/X11/usr/share/gnuplot/gnuplot.gih $(CURDIR)/debian/tmp/X11/usr/share/gnuplot/gnuplot-x11.gih
	$(MAKE) -C $(BUILDDIR_QT) install DESTDIR=$(CURDIR)/debian/tmp/QT/ \
		pkglibexecdir='$$(libexecdir)'
	mv $(CURDIR)/debian/tmp/QT/usr/bin/gnuplot $(CURDIR)/debian/tmp/QT/usr/bin/gnuplot-qt
	mv $(CURDIR)/debian/tmp/QT/usr/share/man/man1/gnuplot.1 $(CURDIR)/debian/tmp/QT/usr/share/man/man1/gnuplot-qt.1
	mv $(CURDIR)/debian/tmp/QT/usr/share/gnuplot/gnuplot.gih $(CURDIR)/debian/tmp/QT/usr/share/gnuplot/gnuplot-qt.gih
	rm -f $(CURDIR)/../demo/Makefile
	rm -f $(CURDIR)/../demo/plugin/Makefile
	rm -f $(BUILDDIR_X11)/demo/Makefil*
	rm -f $(BUILDDIR_X11)/demo/plugin/Makefil*

override_dh_installinfo:
	dh_installinfo -pgnuplot-doc $(BUILDDIR_X11)/docs/gnuplot.info

override_installchangelogs:
	dh_installchangelogs -pgnuplot-doc ChangeLog

override_dh_installman-arch:
	dh_installman -a
	# Fix manpage for nox-version. (Closes: #744218)
	sed -i 's/\[X11 options\] //g' $(MANPNOX)
	sed -i 's/plotting program/plotting program (no-X version)/g' $(MANPNOX)
	sed -i '/SH\ X11\ OPTIONS/,/command line\./ d' $(MANPNOX)

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDDIR_NOX)
	rm -rf $(BUILDDIR_X11)
	rm -rf $(BUILDDIR_QT)

override_dh_compress-indep:
	dh_compress -i -Xexamples -Xtutorial -Xhtmldocs -X.dvi -X.pdf -X.ps
